Program Install;

uses crt, Dos;

{
var c:char;
begin
  WriteLn(ParamStr(0));
  repeat
    c := readkey;
    writeln(ord(c));
  until c=#27;
end.
}


var
  DestDir: String;
  SourceDir: String;
  DummyS: String;
  s: String;
  c: Char;



procedure Error(s: String);
begin
  NormVideo;
  clrscr;
  WriteLn('FEHLER: '+s);
  WriteLn('Installation wurde abgebrochen');
  halt(1);
end;

procedure Wait;
begin
  if ReadKey=#27 then
    Error('vom Benutzer abgebrochen');
end;

procedure TestBreak;
begin
  if Keypressed then
  begin
    if ReadKey=#27 then
      Error('vom Benutzer abgebrochen');
  end;
end;


procedure BackGround(Y1, Y2: Integer);
 var
    i: Integer;
begin
  TextBackground(Black);
  ClrScr;
  TextColor(Blue);
  TextBackground(LightGray);
  for i:= Y1 to Y2 do
  begin
    GotoXY(1, i);
    Write('');
  end;
end;

procedure Box(X1, Y1, X2, Y2: Integer);
 var i: integer;
begin
  TextColor(White);
  TextBackGround(Blue);
  GotoXY(X1, Y1);
  Write(''+copy('',1, X2-X1-1)+'');
  for i := Y1+1 to Y2-1 do
  begin
    GotoXY(X1, i);
    Write(''+copy('                                                                            ',1,X2-X1-1)+'');
  end;
  GotoXY(X1, Y2);
  Write(''+copy('',1, X2-X1-1)+'');
  TextColor(DarkGray);
  TextBackGround(Black);
  for i := Y1+1 to Y2 do
  begin
    GotoXY(X2+1, i);
    Write('');
  end;
  GotoXY(X1+2, Y2+1);
  Write(copy('',1, X2-X1+1));
  TextColor(White);
  TextBackGround(Blue);
end;

function ExistDir(DirName: String): Boolean;
var
  DirInfo: SearchRec;
begin
  FindFirst(DirName, Directory, DirInfo);
  ExistDir := (DosError = 0);
end;



procedure CopyFile(Src, Dst: String);
 var
    FileIn, FileOut: File;
    Buffer: array[0..4095] of byte;
    NumRead, NumWritten: Word;
    FAttr: Word;
    FTime: LongInt;
begin
  GotoXY(22,14);
  Write(copy('Kopiere '+Src+'              ',1,36));
  assign(FileIn, Src);
  GetFAttr(FileIn, FAttr);
  Reset(FileIn, 1);
  assign(FileOut, Dst);
  SetFAttr(FileOut, FAttr);
  Rewrite(FileOut, 1);
  GetFTime(FileIn, FTime);
  repeat
    BlockRead(FileIn, Buffer, SizeOf(Buffer), NumRead);
    BlockWrite(FileOut, Buffer, NumRead, NumWritten);
  until (NumRead=0) or (NumRead<>NumWritten);
  testBreak;
  if (NumRead<>0) then
    Error('beim Kopieren der Datei: '+Src);
  reset(FileOut);
  SetFTime(FileOut, FTime);
  Close(FileIn);
  Close(FileOut);
end;

Procedure CopyDisk(Nr: Integer; Src, Dst, Mask, MustExist: String);
var
  DirInfo: SearchRec;
begin
  repeat
    Box(20, 10, 62, 17);
    GotoXY(22,12);
    Write('Diskette ',Nr,' einlegen und Taste Drcken');
    Wait;
    GotoXY(22,12); WriteLn('              DISKETTE ',Nr,'             ');
    FindFirst(Src+'\'+MustExist, Archive, DirInfo);
  until DosError=0;


  FindFirst(Src+'\'+Mask, Archive, DirInfo);
  while DosError = 0 do
  begin
    if DirInfo.Name<>'INSTALL.EXE' then
      CopyFile(Src+'\'+DirInfo.Name, Dst+'\'+DirInfo.Name);
    FindNext(DirInfo);
  end;
end;


function GetString(X, Y, W: integer; S: String): String;
 var
    Pos: Integer;
    c, c2: char;
    FirstChar: Boolean;
begin
  FirstChar := True;
  TextColor(Blue);
  TextBackground(White);
  Pos := Length(S);
  repeat
    S := copy(s+'                                                          ', 1, W);
    if Pos>=W then
      Pos := W-1;
    if Pos<0 then
      Pos := 0;
    GotoXY(X, Y);
    Write(s);
    GotoXY(X+Pos, Y);
    c2 := #0;
    c := ReadKey;
    if (c=#0) and Keypressed then
      c2 := ReadKey;
    if c>=' ' then
    begin
      if FirstChar then
      begin
        s := c;
        Pos := 1;
      end
      else
      begin
        s := copy(s,1,Pos)+c+copy(s,pos+1,W);
        Pos := Pos+1;
      end;
    end
    else
    if c=#8 then
    begin
      s := copy(s,1,Pos-1)+copy(s,Pos+1,w);
      Pos := Pos-1;
    end
    else
    if c2=#83 then
      s := copy(s,1,Pos)+copy(s,Pos+2,w)
    else
    if (c2=#75) then
      Pos := Pos-1
    else
    if (c2=#77) then
      Pos := Pos+1
    else
    if (c2=#71) then
      Pos := 0
    else
    if (c2=#79) then
    begin
      Pos := w;
      while (Pos>0) and (s[Pos]=' ') do
        Pos := Pos-1;
    end
    else
    if c=#27 then
      Error('vom Benutzer abgebrochen');
    FirstChar := False;
  until (c=#13);
  TextColor(White);
  TextBackGround(Blue);
  While (s<>'') and (s[length(s)]=' ') do
    s := copy(s, 1, length(s)-1);
  GetString := s;
end;


begin
  BackGround(1,25);
  Box(10, 7, 70, 20);
  GotoXY(15, 9);
  Write('Wilkommen zum Installationsprogramm von PORTOS/Dos');
  GotoXY(15, 12);
  Write('Geben Sie nun das Zielverzeichnis ein:');
  DestDir := GetString(15,14,50,'C:\PLZ');
  FSplit(FExpand(ParamStr(0)),SourceDir,DummyS,DummyS);
  if SourceDir='' then
    GetDir(0, SourceDir);
  if SourceDir[length(SourceDir)]='\' then
    SourceDir := copy(SourceDir,1,length(SourceDir)-1);
  GotoXY(15, 16);
  Write('Geben Sie nun das Quelllaufwerk ein:');
  SourceDir := GetString(15,18,50,SourceDir);
  if SourceDir[length(SourceDir)]='\' then
    SourceDir := copy(SourceDir,1,length(SourceDir)-1);
  if DestDir[length(DestDir)]='\' then
    DestDir := copy(DestDir,1,length(DestDir)-1);

  if ExistDir(DestDir) then
  begin
    Box(20, 11, 62,16);
    GotoXY(22, 13);
    Write('Das Zielverzeichnis existiert bereits!');
    GotoXY(22, 14);
    Write('Trotzdem weitermachen (J/N)? ');
    repeat
      c := readkey;
    until c in ['j','J','n','N',#27];
    if c in ['n','N',#27] then
      Error('Zielverzeichnis existierte bereits');
  end
  else
  begin
    {$I-}
    MkDir(DestDir);
    {$I+}
    if (IOResult<>5) and (IOResult<>0) then
      Error('beim Erzeugen des Verzeichnisses: '+DestDir);
  end;
  if not ExistDir(DestDir) then
    Error('Das Zielverzeichnis konnte nicht korrekt angelegt werden');

{
  CopyDisk(1, SourceDir, DestDir, '*.*', 'PLZ.EXE');
  CopyDisk(2, SourceDir, DestDir, '*.*', 'PLZSORT.DBF');
}
  CopyDisk(1, SourceDir, DestDir, '*.*', 'INSTALL.EXE');

  Box(10, 7, 70, 20);
  GotoXY(15, 9);
  Write('Wilkommen zum Installationsprogramm von PORTOS/Dos');
  GotoXY(15, 11);
  Write('Die Installation ist nun abgeschlossen.');
  GotoXY(15, 12);
  Write('Zum starten von PORTOS/Dos geben Sie folgende');
  GotoXY(15, 13);
  Write('Zeilen ein:');
  GotoXY(20, 15);
  Write(Copy(DestDir,1,2));
  GotoXY(20, 16);
  Write('CD '+Copy(DestDir,3,50));
  GotoXY(20, 17);
  Write('PLZ');
  GotoXY(15,19);
  Write('Drcken Sie nun eine Taste');
  readkey;
  NormVideo;
  ClrScr;
end.